/* CGETSTR.C -- Get string function using the system input in Turbo C	*/
/* Without the problems of cgets()										*/
/*																		*/
/* Resembles fgets() in syntax, but no input of file.					*/
/* Correct use of current text attribute								*/

#include <conio.h>
#include <bios.h>

char *cgetstr(char *str, int len)
{
	int n, key;

	len--;						/* Space for null character				*/
	n = 0;

	do
	{
		key = bioskey(0);

		if ( key & 0xFF )
			key &= 0xFF;

		if ( ( key >= ' ' ) && ( key < 255 ) )
		{
			if ( n < len )
			{
				putch(key);
				str[n++] = key;
			}
		}
		else
		{
			switch ( key )
			{
				case '\b' :
							if ( n > 0 )
							{
								gotoxy( wherex() - 1, wherey() );
								putch(' ');
								gotoxy( wherex() - 1, wherey() );
								n--;
							}
							break;
			}
		}
	}
	while ( key != '\r' );

	str[n] = '\0';

	return(str);
}