/* DOSDRIVE.H -- defines macros which allows use of a char value with a letter,
   consistently, when using drive-dependent DOS functions in C

   (Constructed for Turbo C ver 2.0)


   */

#if !defined(_DOSDRIVE_H)

#define _DOSDRIVE_H

#ifdef __cplusplus
extern "C" {
#endif

#define dr2one(Dr) ((Dr)&0x1F)
#define dr2zero(Dr) (dr2one(Dr)-1)
#define one2dr(Dr) ((Dr)+'@')
#define zero2dr(Dr) ((Dr)+'A')
#define normalizedr(Dr) (((Dr)&0x1F)+'@')

#define absread(A,B,C,D) absread(dr2zero(A),B,C,D)
#define abswrite(A,B,C,D) abswrite(dr2zero(A),B,C,D)
#define biosdisk(A,B,C,D,E,F,G) biosdisk(A,dr2zero(B),C,D,E,F,G)
#define getcurdir(A,B) getcurdir(dr2one(A),B)
#define getdfree(A,B) getdfree(dr2one(A),B)
#define getdrive() zero2dr(getdisk())
#define setdrive(D) setdisk(dr2zero(D))

#ifdef __cplusplus
}
#endif

#endif
