/*                                                                          */
/*	FQFN.C	-- A HPAPLUS function providing a "fully qualified file name"	*/
/*																			*/

#include <dir.h>
#include <string.h>
#include <stdlib.h>				/* For definition of NULL					*/
#include <dos.h>
#include <pushpop.h>

char *fqfn(char *inname, char *outname)
/*	outname should have at least MAXPATH characters open, or be NULL which	*/
/*	makes it point to a (returned) static buffer in the fqfn() function		*/
{
	static char buffer[MAXPATH];
	static char *nbegin = "A:\\";

	int status, drive;
	char i_drive[MAXDRIVE], i_dir[MAXDIR], i_file[MAXFILE], i_ext[MAXEXT];
	char curdir[MAXDIR], tdir[MAXDRIVE+MAXDIR-1];

	char *ch1, *ch2;



	if ( outname == NULL )
		outname = buffer;

    if ( _osmajor < 3 )
    {
        status = fnsplit(inname,i_drive,i_dir,i_file,i_ext);

        if ( status & DRIVE )
        {
            drive = i_drive[0] & 0x1F;
        }
        else
            drive = getdisk() + 1;

        getcurdir(drive,curdir);

        strcpy(tdir,i_drive);
        ch1 = tdir + strlen(tdir);

        strcpy(ch1,i_dir);
        ch2 = ch1 + strlen(ch1) - 1;

        if ( *ch2 == '\\' )
            *ch2 = '\0';

        chdir(tdir);

        strcpy(outname,nbegin);
        outname[0] = drive + '@';
        getcurdir(drive,outname+3);

        *ch1 = '\\';
        strcpy(ch1+1,curdir);
        chdir(tdir);

        ch1 = outname + strlen(outname);

        if ( *(ch1-1) != '\\' )
        {
            *(ch1++) = '\\';
        }

        strcpy(ch1,i_file);
        strcat(ch1,i_ext);
    }
    else
    {

#if defined(__TINY__) || defined(__SMALL__) || defined(__MEDIUM__)

        pushreg(SI);
        pushreg(DI);

        _ES = _DS;
        _SI = (unsigned) inname;
        _DI = (unsigned) outname;

        _AX = 0x6000;
        geninterrupt(0x21);

        popreg(DI);
        popreg(SI);
#else
        pushreg(DS);
        pushreg(SI);
        pushreg(DI);

        _DS = FP_SEG(inname);
        _ES = FP_SEG(outname);
        _SI = FP_OFF(inname);
        _DI = FP_SEG(outname);

        _AX = 0x6000;
        geninterrupt(0x21);

        popreg(DI);
        popreg(SI);
        popreg(DS);
#endif
    }

	return(outname);
}
