#pragma inline
/*                                                                          */
/*  HMEMCPY.C   -- The function hugememcpy(), a part of the HPAPLUS package */
/*                                                                          */

#include "standard.h"
#include <dos.h>


void far *hugememcpy(void far *dest, const void far *sco, unsigned long len)
{
    asm push ds

    asm cld

    asm mov ax,len[0]                   /* LSW of len                       */
    asm mov dx,len[2]                   /* MSW of len                       */

    asm lds si,sco
    asm les di,dest

    asm cmp si,di
    asm je Equal_Offset
    asm ja SI_Large

DI_Large:
    asm mov cx,di
    asm sub cx,si

    asm call Do_MOVS

    asm mov bx,es                       /* Move up one segment              */
    asm add bx,1000h                    /* DI advanced by MOVS...           */
    asm mov es,bx

SI_Large:
    asm mov cx,si
    asm sub cx,di

    asm call Do_MOVS

    asm mov bx,ds
    asm add bx,1000h
    asm mov ds,bx

    asm jmp short DI_Large


Equal_Offset:
    asm and si,si                       /* Is SI (and DI) equal to zero?    */
    asm je Move_Seg

    asm mov cx,si                       /* Negative offset = bytes left     */
    asm neg cx

    asm call Do_MOVS

None_Large:
    asm mov bx,es
    asm add bx,1000h
    asm mov es,bx
    asm mov bx,ds
    asm add bx,1000h
    asm mov ds,bx

Move_Seg:
    asm mov cx,8000h
    asm call Do_MOVS
    asm mov cx,8000h
    asm call Do_MOVS

    asm jmp short None_Large



Do_MOVS:
    asm Do_MOVS label near
    asm and dx,dx                       /* Is DX zero?                      */
    asm jnz MOVS_Transfer               /* If so, more a segment left       */
    asm cmp cx,ax                       /* Check this segment               */
    asm jbe Last_Transfer

MOVS_Transfer:
    asm MOVS_Transfer label near
    asm sub ax,cx                       /* Decrease from left-counter       */
    asm sbb dx,0
    asm shr cx,1                        /* MOVSW quicker than MOVSB         */
    asm jnc MOVSW
    asm movsb

MOVSW:
    asm rep movsw

    asm retn                            /* Near return                      */


Last_Transfer:
    asm pop bx                          /* No return address needed         */
    asm mov cx,ax
    asm call MOVS_Transfer

    asm pop ds

    return(dest);
}

