/* MISCPLUS.H -- Noncategorizable HPA lib extensions						*/

#ifndef _MISCPLUS_H

#define _MISCPLUS_H

#include <dos.h>

#ifdef __STDC__
#define _Cdecl
#else
#define _Cdecl		cdecl
#endif

#ifdef __cplusplus
extern "C" {
#endif

char * _Cdecl seekswitch(int *argc, char *argv[]);
int realtime(int *year, int *month, int *day, int *hour, int *min, int *sec);
int updateclock(void);

#define nop()	__emit__(0x90)

enum
{
    _PUSH_REG_OPCODE_AX = 0x50,
    _PUSH_REG_OPCODE_BX = 0x53,
    _PUSH_REG_OPCODE_CX = 0x51,
    _PUSH_REG_OPCODE_DX = 0x52,
    _PUSH_REG_OPCODE_SP = 0x54,
    _PUSH_REG_OPCODE_BP = 0x55,
    _PUSH_REG_OPCODE_SI = 0x56,
    _PUSH_REG_OPCODE_DI = 0x57,
    _PUSH_REG_OPCODE_CS = 0x0E,
    _PUSH_REG_OPCODE_DS = 0x1E,
    _PUSH_REG_OPCODE_ES = 0x06,
    _PUSH_REG_OPCODE_SS = 0x16,
    _PUSH_REG_OPCODE_FLAGS = 0x9C,
    _POP_REG_OPCODE_AX  = 0x58,
    _POP_REG_OPCODE_BX  = 0x5B,
    _POP_REG_OPCODE_CX  = 0x59,
    _POP_REG_OPCODE_DX  = 0x5A,
    _POP_REG_OPCODE_SP  = 0x5C,
    _POP_REG_OPCODE_BP  = 0x5D,
    _POP_REG_OPCODE_SI  = 0x5E,
    _POP_REG_OPCODE_DI  = 0x5F,
    _POP_REG_OPCODE_DS  = 0x1F,
    _POP_REG_OPCODE_ES  = 0x07,
    _POP_REG_OPCODE_SS  = 0x17,
    _POP_REG_OPCODE_FLAGS = 0x9D
};

#define pushreg(R)      __emit__( _PUSH_REG_OPCODE_ ## R )
#define popreg(R)       __emit__( _POP_REG_OPCODE_ ## R )

#ifdef __cplusplus
}
#endif

#endif
