#include <dos.h>
#include <stdarg.h>
#include <stdlib.h>

#define mouseint() geninterrupt(0x33)		/* Converts to an INT 33H instr. */

#if defined(__COMPACT__) || defined(__LARGE__) || defined(__HUGE__)
#define LARGEDATA		1
#endif

int mousepress(int button,int *count,int *xpos,int *ypos)
/* For button no ( button ) 0 = left, 1 = right:
   Get number of presses since last call ( *count )
   Get position where pressed last time ( *xpos, *ypos )
   Get current status ( return value; 0 = rel., 1 = pressed )
   */
{
	int cnt, x, y, state;

	_AX = 5;
	_BX = button;

	mouseint();

	state = _AX;
	cnt = _BX;
	x = _CX;
	y = _DX;

	if ( count != NULL )
		*count = cnt;

	if ( xpos != NULL )
		*xpos = x;

	if ( ypos != NULL )
		*ypos = y;

	return( state );
}


int mouserelease(int button,int *count,int *xpos,int *ypos)
/* For button no ( button ) 0 = left, 1 = right:
   Get number of releases since last call ( *count )
   Get position where released last time ( *xpos, *ypos )
   Get current status ( return value; 0 = rel., 1 = pressed )
   */
{
	int cnt, x, y, state;

	_AX = 6;
	_BX = button;

	mouseint();

	state = _AX;
	cnt = _BX;
	x = _CX;
	y = _DX;

	if ( count != NULL )
		*count = cnt;

	if ( xpos != NULL )
		*xpos = x;

	if ( ypos != NULL )
		*ypos = y;

	return( state );
}

