/*																			*/
/*	UNIXTIME.C	-- File time functions converting between UNIX and DOS time	*/
/*																			*/

#include <io.h>
#include <stdio.h>
#include <time.h>

enum boolean { FALSE, TRUE };

time_t getfiletime(FILE *stream)
{
	struct ftime ftim;
	struct tm tim;
	time_t filetime;

	getftime(fileno(stream),&ftim);

	tim.tm_sec = ftim.ft_tsec << 1;
	tim.tm_min = ftim.ft_min;
	tim.tm_hour = ftim.ft_hour;
	tim.tm_mday = ftim.ft_day;
	tim.tm_mon = ftim.ft_month - 1;
	tim.tm_year = ftim.ft_year + 80;

	filetime = mktime(&tim);

	return(filetime);
}


int setfiletime(time_t filetime, FILE *stream)
{
	struct ftime ftim;
	struct tm *tim;

	tim = localtime(&filetime);

	ftim.ft_tsec = (tim -> tm_sec) >> 1;
	ftim.ft_min = tim -> tm_min;
	ftim.ft_hour = tim -> tm_hour;
	ftim.ft_day = tim -> tm_mday;
	ftim.ft_month = (tim -> tm_mon) + 1;
	ftim.ft_year = (tim -> tm_year) - 80;

	return(setftime(fileno(stream),&ftim));
}