/* WINDOW.H symbolic constants and prototypes for window functions */

#ifndef _WINDOW_H

#ifdef __STDC__
#define _Cdecl
#else
#define _Cdecl cdecl
#endif

#define _WINDOW_H 1
#ifdef __cplusplus
extern "C" {
#endif


enum WSTAT { W_OK, W_NOTINIT, W_NOSPACE, W_EMPTY, W_RANGE, W_ILLEGAL };
enum WMODE { W_NORMAL, W_SPECIAL };
enum WSTYLE { W_SINGLE, W_DOUBLE, W_DVERT, W_DHORIZ, W_NOBORDER = 64,
    W_SHADOW = 128 };

#define zerowindows() while( killwindow() == W_OK )

enum WSTAT _Cdecl initwindows(int size, int limit);
enum WSTAT _Cdecl disablewindows(void);
enum WSTAT _Cdecl makewindow(int x, int y, int xsize, int ysize, enum WMODE mode);
enum WSTAT _Cdecl killwindow(void);
enum WSTAT _Cdecl labelwindow(char *name, int color);

extern int WindowColor;
extern enum WSTYLE WindowStyle;

#ifdef __cplusplus
}
#endif

#endif
