/* WINDOW03.C contains window-handling functions for Turbo C, part 3 */

#include <dos.h>
#include <stdio.h>
#include "window.h"
#include <conio.h>
#include <crtplus.h>
#include <string.h>
#include <strplus.h>

struct WindowSysStruct
{
	unsigned *storage;
	unsigned *bufptr;
	int wsize;
	int wlim;
	int spaceleft;
    int maxcol;
    int maxline;
    int shadowwid;
    int colour;
};




extern struct WindowSysStruct _WindowSys;


#define order(a,b) if (a>b) { dummy = a; a=b; b=dummy; }
#define TESTINIT if ( _WindowSys.bufptr == NULL ) return(W_NOTINIT)
#define xwindows() ( _WindowSys.spaceleft < _WindowSys.wsize )



enum WSTAT labelwindow(char name[], int lcolor)
/* Put a label on current window, centered on top border with spaces
   If ( *name == '\0' ) draw continous top line
   Exit codes:
   W_OK			Successful operation
   W_NOTINIT	initwindows() not successfully completed
   W_EMPTY		No window on screen
   W_NOSPACE	Top line too short ( label truncated )
   */

{
	char prncopy[80];
	int x, y, xsize, ysize, savex, savey, wcolor, i;
	unsigned *wptr;
	enum WSTYLE border;
	char tlc;				/* Top line character */


	TESTINIT;

	if ( !xwindows() )
		return(W_EMPTY);

	savex = wherex();
	savey = wherey();

	wptr = _WindowSys.bufptr;

	x = *(--wptr);
	y = *(--wptr);
	wptr -= 2;
	xsize = *(--wptr);
	ysize = *(--wptr);
	wcolor = *(--wptr);
	border = *(--wptr) & 3;

	textattr(wcolor);

	window( x, y, x+xsize+5, y+ysize+1 );
	gotoxy( 2, 1 );
	tlc = ( border == W_SINGLE || border == W_DVERT ) ? '' : '';

	for ( i = xsize+2 ; i ; i-- );
        putch(tlc);

	if ( *name )
	{
		textattr(lcolor);

		i = xsize - strlen(name);

		if ( i < 0 )
		{
			strmid(prncopy,name,0,xsize);
			gotoxy( 4, 1 );
			cprintf(" %s ",prncopy);

			i = W_NOSPACE;
		}
		else
		{
			gotoxy( 4 + i/2, 1 );
			cprintf(" %s ",name);

			i = W_OK;
		}
	}
	else
		i = W_OK;

	window( x+4, y+1, x+xsize+4, y+ysize );
	gotoxy(savex,savey);

	return(i);
}
